diff --git a/arch/arm/dts/zynqmp-zcu102-rev1.0.dts b/arch/arm/dts/zynqmp-zcu102-rev1.0.dts
index d508f3359943..932d86f53b45 100644
--- a/arch/arm/dts/zynqmp-zcu102-rev1.0.dts
+++ b/arch/arm/dts/zynqmp-zcu102-rev1.0.dts
@@ -16,21 +16,25 @@
 
 &eeprom {
 	#address-cells = <1>;
-	#size-cells = <1>;
+	#size-cells = <0>;
+	partitions {
+		#address-cells = <1>;
+		#size-cells = <1>;
 
-	board_sn: board-sn@0 {
-		reg = <0x0 0x14>;
-	};
+		board_sn: board-sn@0 {
+			reg = <0x0 0x14>;
+		};
 
-	eth_mac: eth-mac@20 {
-		reg = <0x20 0x6>;
-	};
+		eth_mac: eth-mac@20 {
+			reg = <0x20 0x6>;
+		};
 
-	board_name: board-name@d0 {
-		reg = <0xd0 0x6>;
-	};
+		board_name: board-name@d0 {
+			reg = <0xd0 0x6>;
+		};
 
-	board_revision: board-revision@e0 {
-		reg = <0xe0 0x3>;
+		board_revision: board-revision@e0 {
+			reg = <0xe0 0x3>;
+		};
 	};
 };
diff --git a/arch/arm/dts/zynqmp-zcu104-revA.dts b/arch/arm/dts/zynqmp-zcu104-revA.dts
index a4bd6b800a18..f3ab34e1f958 100644
--- a/arch/arm/dts/zynqmp-zcu104-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu104-revA.dts
@@ -129,7 +129,28 @@
 				compatible = "atmel,24c08";
 				reg = <0x54>;
 				#address-cells = <1>;
-				#size-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 
diff --git a/arch/arm/dts/zynqmp-zcu104-revC.dts b/arch/arm/dts/zynqmp-zcu104-revC.dts
index d4b3769a27cc..ffa1ca34034a 100644
--- a/arch/arm/dts/zynqmp-zcu104-revC.dts
+++ b/arch/arm/dts/zynqmp-zcu104-revC.dts
@@ -154,7 +154,28 @@
 				compatible = "atmel,24c08";
 				reg = <0x54>;
 				#address-cells = <1>;
-				#size-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 
diff --git a/arch/arm/dts/zynqmp-zcu106-revA.dts b/arch/arm/dts/zynqmp-zcu106-revA.dts
index 221685fd23be..df473db60c22 100644
--- a/arch/arm/dts/zynqmp-zcu106-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu106-revA.dts
@@ -483,6 +483,29 @@
 			eeprom: eeprom@54 { /* u23 */
 				compatible = "atmel,24c08";
 				reg = <0x54>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 		i2c@1 {
diff --git a/arch/arm/dts/zynqmp-zcu111-revA.dts b/arch/arm/dts/zynqmp-zcu111-revA.dts
index 63e285fe9a9a..e3b4573c19d9 100644
--- a/arch/arm/dts/zynqmp-zcu111-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu111-revA.dts
@@ -379,6 +379,29 @@
 			eeprom: eeprom@54 { /* u88 */
 				compatible = "atmel,24c08";
 				reg = <0x54>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 		i2c@1 {
diff --git a/arch/arm/dts/zynqmp-zcu1285-revA.dts b/arch/arm/dts/zynqmp-zcu1285-revA.dts
index d8b9cb1a9e13..b829a8a5cd85 100644
--- a/arch/arm/dts/zynqmp-zcu1285-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu1285-revA.dts
@@ -152,6 +152,29 @@
 			eeprom: eeprom@54 { /* u101 */
 				compatible = "atmel,24c32"; /* 24LC32A */
 				reg = <0x54>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 		i2c@3 {
diff --git a/arch/arm/dts/zynqmp-zcu208-revA.dts b/arch/arm/dts/zynqmp-zcu208-revA.dts
index 118a2de96b3c..4dc0aaf55873 100644
--- a/arch/arm/dts/zynqmp-zcu208-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu208-revA.dts
@@ -397,6 +397,29 @@
 			eeprom: eeprom@54 { /* u21 */
 				compatible = "atmel,24c128";
 				reg = <0x54>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 		i2c_si5341: i2c@1 {
diff --git a/arch/arm/dts/zynqmp-zcu216-revA.dts b/arch/arm/dts/zynqmp-zcu216-revA.dts
index e454bfcba797..b643335da058 100644
--- a/arch/arm/dts/zynqmp-zcu216-revA.dts
+++ b/arch/arm/dts/zynqmp-zcu216-revA.dts
@@ -401,6 +401,29 @@
 			eeprom: eeprom@54 { /* u21 */
 				compatible = "atmel,24c128";
 				reg = <0x54>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				partitions {
+					compatible = "fixed-partitions";
+					#address-cells = <1>;
+					#size-cells = <1>;
+
+					board_sn: board-sn@0 {
+						reg = <0x0 0x14>;
+					};
+
+					eth_mac: eth-mac@20 {
+						reg = <0x20 0x6>;
+					};
+
+					board_name: board-name@d0 {
+						reg = <0xd0 0x6>;
+					};
+
+					board_revision: board-revision@e0 {
+						reg = <0xe0 0x3>;
+					};
+				};
 			};
 		};
 		i2c_si5341: i2c@1 {